| The Gaudi Framework v30r0 (c919700c)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
ToolHandle< T > Class Template Reference

Handle to be used in lieu of naked pointers to tools. More...

`#include <GaudiKernel/ToolHandle.h>`

Inheritance diagram for ToolHandle< T >:
[legend]
Collaboration diagram for ToolHandle< T >:
[legend]

## Public Member Functions
| ToolHandle (const IInterface *parent=nullptr, bool createIf=true)
| Constructor for a tool with default tool type and name. More...
template<typename CT = T, typename NCT = typename std::remove_const<T>::type>
| ToolHandle (const ToolHandle< NCT > &other, typename std::enable_if< std::is_const< CT >::value &&!std::is_same< CT, NCT >::value >::type *=nullptr)
| Copy constructor from a non const T to const T tool handle. More...
| ToolHandle (const std::string &toolTypeAndName, const IInterface *parent=nullptr, bool createIf=true)
| Create a handle ('smart pointer') to a tool. More...
template<class OWNER , typename = std::enable_if_t<std::is_base_of<IProperty, OWNER>::value>>
| ToolHandle (OWNER *owner, std::string name, std::string toolType, std::string doc="")
| Autodeclaring constructor with property name, tool type/name and documentation. More...
StatusCode | initialize (const std::string &toolTypeAndName, const IInterface *parent=nullptr, bool createIf=true)
StatusCode | retrieve () const override
| Retrieve the AlgTool. More...
StatusCode | release () const
| Release the AlgTool. More...
StatusCode | retrieve (T *&algTool) const override
| Do the real retrieval of the AlgTool. More...
StatusCode | release (T *algTool) const override
| Do the real release of the AlgTool. More...
std::string | typeAndName () const override
std::add_const< T >::type * | get () const
T * | get ()
Public Member Functions inherited from BaseToolHandle
StatusCode | retrieve (IAlgTool *&tool) const
const IAlgTool * | get () const
IAlgTool * | get ()
bool | isEnabled () const
| Helper to check if the ToolHandle should be retrieved. More...
void | enable ()
void | disable ()
bool | setEnabled (const bool flag)
Public Member Functions inherited from ToolHandleInfo
virtual | ~ToolHandleInfo ()=default
bool | isPublic () const noexcept
bool | createIf () const noexcept
const IInterface * | parent () const noexcept
Public Member Functions inherited from GaudiHandle< T >
template<typename CT = T, typename NCT = typename std::remove_const<T>::type>
| GaudiHandle (const GaudiHandle< NCT > &other, typename std::enable_if< std::is_const< CT >::value &&!std::is_same< CT, NCT >::value >::type *=nullptr)
| Copy constructor needed for correct ref-counting. More...
| GaudiHandle (const GaudiHandle &other)
| Copy constructor needed for correct ref-counting. More...
template<typename CT = T, typename NCT = typename std::remove_const<T>::type>
std::enable_if< std::is_const< CT >::value &&!std::is_same< CT, NCT >::value, GaudiHandle & >::type | operator= (const GaudiHandle< NCT > &other)
| Assignment operator for correct ref-counting. More...
GaudiHandle & | operator= (const GaudiHandle &other)
| Assignment operator for correct ref-counting. More...
StatusCode | retrieve () const
| Retrieve the component. More...
StatusCode | release () const
| Release the component. More...
bool | isValid () const
| Check if the handle is valid (try to retrive the object is not done yet). More...
| operator bool () const
| For testing if handle has component. More...
T * | get ()
| Return the wrapped pointer, not calling retrieve() if null. More...
std::add_const< T >::type * | get () const
| Return the wrapped pointer, not calling retrieve() if null. More...
bool | isSet () const
| True if the wrapped pointer is not null. More...
T & | operator* ()
T * | operator-> ()
std::add_const< T >::type & | operator* () const
std::add_const< T >::type * | operator-> () const
std::string | getDefaultType ()
| Helper function to get default type string from the class type. More...
std::string | getDefaultName ()
Public Member Functions inherited from GaudiHandleBase
std::string | typeAndName () const
| The full type and name: "type/name". More...
std::string | type () const
| The concrete component class name: the part before the '/'. More...
std::string | name () const
| The instance name: the part after the '/'. More...
bool | empty () const
| Check if the handle has been set to empty string (i.e. More...
void | setTypeAndName (std::string myTypeAndName)
| The component "type/name" string. More...
void | setName (const std::string &myName)
| Set the instance name (part after the '/') without changing the class type. More...
std::string | pythonPropertyClassName () const override
| Name of the componentType with "Handle" appended. More...
std::string | messageName () const
| name used for printing messages More...
std::string | pythonRepr () const override
| Python representation of handle, i.e. More...
Public Member Functions inherited from GaudiHandleInfo
virtual | ~GaudiHandleInfo ()=default
| virtual destructor so that derived class destructor is called. More...
const std::string & | componentType () const
const std::string & | propertyName () const
| name as used in declareProperty(name,gaudiHandle) More...
void | setPropertyName (std::string propName)
| set name as used in declareProperty(name,gaudiHandle). More...
const std::string & | parentName () const
| The name of the parent. More...

## Protected Member Functions
const IAlgTool * | getAsIAlgTool () const override
IAlgTool * | getAsIAlgTool () override
StatusCode | i_retrieve (IAlgTool *&algTool) const override
Protected Member Functions inherited from BaseToolHandle
| BaseToolHandle (const IInterface *parent=nullptr, bool createIf=true)
Protected Member Functions inherited from ToolHandleInfo
| ToolHandleInfo (const IInterface *parent=nullptr, bool createIf=true)
Protected Member Functions inherited from GaudiHandle< T >
| GaudiHandle (std::string myTypeAndName, std::string myComponentType, std::string myParentName)
Protected Member Functions inherited from GaudiHandleBase
| GaudiHandleBase (std::string myTypeAndName, std::string myComponentType, std::string myParentName)
| Create a handle ('smart pointer') to a gaudi component. More...
Protected Member Functions inherited from GaudiHandleInfo
| GaudiHandleInfo (std::string myComponentType, std::string myParentName)
| Some basic information and helper functions shared between various handles/arrays. More...
void | setComponentType (const std::string &componentType)
| The component type. More...
void | setParentName (const std::string &parent)
| The name of the parent. More...

## Private Attributes
ServiceHandle< IToolSvc > | m_pToolSvc

## Friends
class | Algorithm
class | AlgTool
class | Service

## Additional Inherited Members
Static Public Member Functions inherited from ToolHandleInfo
static std::string | toolComponentType (const IInterface *parent)
static std::string | toolParentName (const IInterface *parent)
Protected Attributes inherited from BaseToolHandle
bool | m_enabled = true
Protected Attributes inherited from ToolHandleInfo
const IInterface * | m_parent = nullptr
bool | m_createIf {true}

## Detailed Description

### template<class T>
class ToolHandle< T >

Handle to be used in lieu of naked pointers to tools.

This allows better control through the framework of tool loading and usage. T is the AlgTool interface class (or concrete class) of the tool to use, and must derive from IAlgTool.

Author
  Wim Lavrijsen WLavr.nosp@m.ijse.nosp@m.n@lbl.nosp@m..gov
  Marti.nosp@m.n.Wo.nosp@m.udstr.nosp@m.a@ce.nosp@m.rn.ch

Definition at line 30 of file PropertyHolder.h.

## Constructor & Destructor Documentation

template<class T>

ToolHandle< T >::ToolHandle | ( | const IInterface * | parent = `nullptr`,
|  | bool | createIf = `true`
| ) |  |
| inline

Constructor for a tool with default tool type and name.

Can be called only if the type T is a concrete tool type (not an interface), and you want to use the default name.

Definition at line 135 of file ToolHandle.h.

136 : BaseToolHandle( parent, createIf )
137 , GaudiHandle<T>( "", toolComponentType( parent ), toolParentName( parent ) )
138 , m_pToolSvc( "ToolSvc", GaudiHandleBase::parentName() )
139 {
140 }
GaudiHandle
Handle to be used in lieu of naked pointers to gaudis.
Definition: GaudiHandle.h:167
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:291
ToolHandleInfo::toolParentName
static std::string toolParentName(const IInterface *parent)
Definition: ToolHandle.h:49
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:57
BaseToolHandle::BaseToolHandle
BaseToolHandle(const IInterface *parent=nullptr, bool createIf=true)
Definition: ToolHandle.h:71
ToolHandleInfo::toolComponentType
static std::string toolComponentType(const IInterface *parent)
Definition: ToolHandle.h:47
ToolHandleInfo::createIf
bool createIf() const noexcept
Definition: ToolHandle.h:39
template<class T>
template<typename CT = T, typename NCT = typename std::remove_const<T>::type>

ToolHandle< T >::ToolHandle | ( | const ToolHandle< NCT > & | other,
|  | typename std::enable_if< std::is_const< CT >::value &&!std::is_same< CT, NCT >::value >::type * | = `nullptr`
| ) |  |
| inline

Copy constructor from a non const T to const T tool handle.

Definition at line 144 of file ToolHandle.h.

146 : BaseToolHandle( other.parent(), other.createIf() )
147 , GaudiHandle<CT>( other )
148 , m_pToolSvc( "ToolSvc", GaudiHandleBase::parentName() )
149 {
150 }
GaudiHandle
Handle to be used in lieu of naked pointers to gaudis.
Definition: GaudiHandle.h:167
ToolHandleInfo::parent
const IInterface * parent() const noexcept
Definition: ToolHandle.h:41
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:291
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:57
BaseToolHandle::BaseToolHandle
BaseToolHandle(const IInterface *parent=nullptr, bool createIf=true)
Definition: ToolHandle.h:71
ToolHandleInfo::createIf
bool createIf() const noexcept
Definition: ToolHandle.h:39
template<class T>

ToolHandle< T >::ToolHandle | ( | const std::string & | toolTypeAndName,
|  | const IInterface * | parent = `nullptr`,
|  | bool | createIf = `true`
| ) |  |
| inline

Create a handle ('smart pointer') to a tool.

The arguments are passed on to ToolSvc, and have the same meaning:

StatusCode ToolSvc::retrieveTool ( const std::string& type ,
T*& tool ,
const IInterface* parent = 0 ,
bool createIf = true )

Parameters

  owner | class owning the ToolHandle
  toolType | "MyToolType/MyToolName" "MyToolType" is short for "MyToolType/MyToolType" 'MyToolType' is the name of the class of the concrete tool 'MyToolName' is to distinguish several tool instances of the same class
  parent | the parent Algorithm,Tool or Service of which this tool is a member. If non-zero, the the tool is a private tool of the parent, otherwise it is a public (shared) tool.
  createIf | if true, create tool if not yet existing.

Definition at line 183 of file ToolHandle.h.

184 : BaseToolHandle( parent, createIf )
185 , GaudiHandle<T>( toolTypeAndName, toolComponentType( parent ), toolParentName( parent ) )
186 , m_pToolSvc( "ToolSvc", GaudiHandleBase::parentName() )
187 {
188 }
GaudiHandle
Handle to be used in lieu of naked pointers to gaudis.
Definition: GaudiHandle.h:167
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:291
ToolHandleInfo::toolParentName
static std::string toolParentName(const IInterface *parent)
Definition: ToolHandle.h:49
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:57
BaseToolHandle::BaseToolHandle
BaseToolHandle(const IInterface *parent=nullptr, bool createIf=true)
Definition: ToolHandle.h:71
ToolHandleInfo::toolComponentType
static std::string toolComponentType(const IInterface *parent)
Definition: ToolHandle.h:47
ToolHandleInfo::createIf
bool createIf() const noexcept
Definition: ToolHandle.h:39
template<class T>
template<class OWNER , typename = std::enable_if_t<std::is_base_of<IProperty, OWNER>::value>>

ToolHandle< T >::ToolHandle | ( | OWNER * | owner,
|  | std::string | name,
|  | std::string | toolType,
|  | std::string | doc = `""`
| ) |  |
| inline

Autodeclaring constructor with property name, tool type/name and documentation.

Note
  the use std::enable_if is required to avoid ambiguities

Definition at line 193 of file ToolHandle.h.

193 : ToolHandle( owner )
194 {
195 // convert name and type to a valid type/name string
196 // - if type does not contain '/' use type/name
197 // - otherwise type is already a type/name string
198 if ( !toolType.empty() and toolType.find( '/' ) == std::string::npos ) {
199 toolType += '/';
200 toolType += name;
201 }
202 owner->declareTool( *this, std::move( toolType ) ).ignore();
203 auto p = owner->OWNER::PropertyHolderImpl::declareProperty( std::move( name ), *this, std::move( doc ) );
204 p->template setOwnerType<OWNER>();
205 }
ToolHandle::ToolHandle
ToolHandle(const IInterface *parent=nullptr, bool createIf=true)
Constructor for a tool with default tool type and name.
Definition: ToolHandle.h:135
std::string::empty
T empty(T...args)
std::move
T move(T...args)
std::string::find
T find(T...args)
GaudiHandleBase::name
std::string name() const
The instance name: the part after the &#39;/&#39;.
Definition: GaudiHandle.cpp:23

## Member Function Documentation

template<class T>

std::add_const<T>::type* ToolHandle< T >::get | ( |  | ) | const
| inline

Definition at line 248 of file ToolHandle.h.

248 { return GaudiHandle<T>::get(); }
GaudiHandle::get
T * get()
Return the wrapped pointer, not calling retrieve() if null.
Definition: GaudiHandle.h:261
template<class T>

T* ToolHandle< T >::get | ( |  | ) |
| inline

Definition at line 250 of file ToolHandle.h.

250 { return GaudiHandle<T>::get(); }
GaudiHandle::get
T * get()
Return the wrapped pointer, not calling retrieve() if null.
Definition: GaudiHandle.h:261
template<class T>

const IAlgTool* ToolHandle< T >::getAsIAlgTool | ( |  | ) | const
| inline override protected virtual

Implements BaseToolHandle.

Definition at line 269 of file ToolHandle.h.

270 {
271 // const cast to support T being const
272 return GaudiHandle<T>::get();
273 }
GaudiHandle::get
T * get()
Return the wrapped pointer, not calling retrieve() if null.
Definition: GaudiHandle.h:261
template<class T>

IAlgTool* ToolHandle< T >::getAsIAlgTool | ( |  | ) |
| inline override protected virtual

Implements BaseToolHandle.

Definition at line 275 of file ToolHandle.h.

276 {
277 // const cast to support T being const
278 return details::nonConst( GaudiHandle<T>::get() );
279 }
GaudiHandle
Handle to be used in lieu of naked pointers to gaudis.
Definition: GaudiHandle.h:167
details::nonConst
std::remove_const_t< T > * nonConst(T *p)
Cast a pointer to a non const type.
Definition: GaudiHandle.h:20
template<class T>

StatusCode ToolHandle< T >::i_retrieve | ( | IAlgTool *& | algTool | ) | const
| inline override protected virtual

Implements BaseToolHandle.

Definition at line 281 of file ToolHandle.h.

282 {
283 return m_pToolSvc->retrieve( typeAndName(), IAlgTool::interfaceID(), algTool, ToolHandleInfo::parent(),
284 ToolHandleInfo::createIf() );
285 }
IToolSvc::retrieve
virtual StatusCode retrieve(const std::string &type, const InterfaceID &iid, IAlgTool *&tool, const IInterface *parent=0, bool createIf=true)=0
Retrieve tool with tool dependent part of the name automatically assigned.
ToolHandleInfo::parent
const IInterface * parent() const noexcept
Definition: ToolHandle.h:41
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:291
ToolHandle::typeAndName
std::string typeAndName() const override
Definition: ToolHandle.h:246
IInterface::interfaceID
static const InterfaceID & interfaceID()
Return an instance of InterfaceID identifying the interface.
Definition: IInterface.h:287
ToolHandleInfo::createIf
bool createIf() const noexcept
Definition: ToolHandle.h:39
template<class T>

StatusCode ToolHandle< T >::initialize | ( | const std::string & | toolTypeAndName,
|  | const IInterface * | parent = `nullptr`,
|  | bool | createIf = `true`
| ) |  |
| inline

Definition at line 208 of file ToolHandle.h.

209 {
210
211 GaudiHandleBase::setTypeAndName( toolTypeAndName );
212 GaudiHandleBase::setComponentType( toolComponentType( parent ) );
213 GaudiHandleBase::setParentName( toolParentName( parent ) );
214
215 m_parent = parent;
216 m_createIf = createIf;
217
218 return m_pToolSvc.initialize( "ToolSvc", GaudiHandleBase::parentName() );
219 }
ToolHandleInfo::parent
const IInterface * parent() const noexcept
Definition: ToolHandle.h:41
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:291
GaudiHandleBase::setTypeAndName
void setTypeAndName(std::string myTypeAndName)
The component "type/name" string.
Definition: GaudiHandle.cpp:9
GaudiHandleInfo::setComponentType
void setComponentType(const std::string &componentType)
The component type.
Definition: GaudiHandle.h:72
ToolHandleInfo::toolParentName
static std::string toolParentName(const IInterface *parent)
Definition: ToolHandle.h:49
GaudiHandleInfo::parentName
const std::string & parentName() const
The name of the parent.
Definition: GaudiHandle.h:57
GaudiHandleInfo::setParentName
void setParentName(const std::string &parent)
The name of the parent.
Definition: GaudiHandle.h:75
ToolHandleInfo::toolComponentType
static std::string toolComponentType(const IInterface *parent)
Definition: ToolHandle.h:47
ServiceHandle::initialize
StatusCode initialize(const std::string &serviceName, const std::string &theParentName)
Definition: ServiceHandle.h:66
ToolHandleInfo::m_parent
const IInterface * m_parent
Definition: ToolHandle.h:56
ToolHandleInfo::m_createIf
bool m_createIf
Definition: ToolHandle.h:57
ToolHandleInfo::createIf
bool createIf() const noexcept
Definition: ToolHandle.h:39
template<class T>

StatusCode ToolHandle< T >::release | ( |  | ) | const
| inline

Release the AlgTool.

Function must be repeated here to avoid hiding the function release( T*& )

Definition at line 230 of file ToolHandle.h.

231 { // not really const, because it updates m_pObject
232 return GaudiHandle<T>::release();
233 }
GaudiHandle::release
StatusCode release() const
Release the component.
Definition: GaudiHandle.h:237
template<class T>

StatusCode ToolHandle< T >::release | ( | T * | algTool | ) | const
| inline override virtual

Do the real release of the AlgTool.

Reimplemented from GaudiHandle< T >.

Definition at line 244 of file ToolHandle.h.

244 { return m_pToolSvc->releaseTool( details::nonConst( algTool ) ); }
ToolHandle::m_pToolSvc
ServiceHandle< IToolSvc > m_pToolSvc
Definition: ToolHandle.h:291
details::nonConst
std::remove_const_t< T > * nonConst(T *p)
Cast a pointer to a non const type.
Definition: GaudiHandle.h:20
IToolSvc::releaseTool
virtual StatusCode releaseTool(IAlgTool *tool)=0
Release the tool.
template<class T>

StatusCode ToolHandle< T >::retrieve | ( |  | ) | const
| inline override virtual

Retrieve the AlgTool.

Release existing tool if needed. Function must be repeated here to avoid hiding the function retrieve( T*& )

Implements BaseToolHandle.

Definition at line 223 of file ToolHandle.h.

224 { // not really const, because it updates m_pObject
225 return GaudiHandle<T>::retrieve();
226 }
GaudiHandle::retrieve
StatusCode retrieve() const
Retrieve the component.
Definition: GaudiHandle.h:223
template<class T>

StatusCode ToolHandle< T >::retrieve | ( | T *& | algTool | ) | const
| inline override virtual

Do the real retrieval of the AlgTool.

Implements GaudiHandle< T >.

Definition at line 236 of file ToolHandle.h.

237 {
238 IAlgTool* iface = nullptr;
239 algTool = i_retrieve( iface ) ? dynamic_cast<T*>( iface ) : nullptr;
240 return algTool ? StatusCode::SUCCESS : StatusCode::FAILURE;
241 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
ToolHandle::i_retrieve
StatusCode i_retrieve(IAlgTool *&algTool) const override
Definition: ToolHandle.h:281
IAlgTool
The interface implemented by the AlgTool base class.
Definition: IAlgTool.h:23
StatusCode::FAILURE
Definition: StatusCode.h:29
template<class T>

std::string ToolHandle< T >::typeAndName | ( |  | ) | const
| inline override virtual

Implements BaseToolHandle.

Definition at line 246 of file ToolHandle.h.

246 { return GaudiHandleBase::typeAndName(); }
GaudiHandleBase::typeAndName
std::string typeAndName() const
The full type and name: "type/name".
Definition: GaudiHandle.h:121

## Friends And Related Function Documentation

template<class T>

friend class Algorithm
| friend

Definition at line 127 of file ToolHandle.h.

template<class T>

friend class AlgTool
| friend

Definition at line 128 of file ToolHandle.h.

template<class T>

friend class Service
| friend

Definition at line 129 of file ToolHandle.h.

## Member Data Documentation

template<class T>

ServiceHandle<IToolSvc> ToolHandle< T >::m_pToolSvc
| mutable private

Definition at line 291 of file ToolHandle.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/PropertyHolder.h
- GaudiKernel/GaudiKernel/ToolHandle.h